/*
 *  linux/arch/arm/mach-ast2000/ast2000.c
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <linux/config.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/irq.h>
#include <asm/setup.h>
#include <asm/mach-types.h>

#include <asm/mach/arch.h>
#include <asm/mach/time.h>

extern void ast2000_map_io(void);
extern void ast2000_init_irq(void);
extern struct sys_timer ast2000_timer;

static void __init ast2000_init(void)
{

}

MACHINE_START(AST2000, "ASPEED-AST2000")
	/* MAINTAINER("ASPEED Technology Inc.") */
	.phys_io		= IO_START,
	.phys_ram		= ASPEED_SDRAM_BASE,
	.io_pg_offst		= (IO_ADDRESS(IO_START)>>18) & 0xfffc,
	.map_io			= ast2000_map_io,
	.timer			= &ast2000_timer,
	.init_irq		= ast2000_init_irq,
	.init_machine		= ast2000_init,
MACHINE_END
