/*
 *  linux/arch/arm/mach-ast2000/ast2000.c
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * AVOCENT - AndyC begin
 * added for kernel upgrade from 2.6.18.6 to 2.6.23.1
 * because linux/config.h no longer exist in kernel 2.6.23.1,
 * need to comment out the include to avoid build error
 */
// #include <linux/config.h>
/* AVOCENT - AndyC end*/

#include <linux/types.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/irq.h>
#include <asm/setup.h>
#include <asm/mach-types.h>

#include <asm/mach/arch.h>
#include <asm/mach/time.h>

extern void aspeed_map_io(void);
extern void aspeed_init_irq(void);
extern struct sys_timer aspeed_timer;

static void __init aspeed_init(void)
{

}

MACHINE_START(AST2050, "ASPEED-AST2050")
	/* MAINTAINER("ASPEED Technology Inc.") */
	.phys_io		= IO_START,
//	.phys_ram		= ASPEED_SDRAM_BASE,   //AVCT: FOR 2.6.18.6 linux kernel

/*
 * AVOCENT - AndyC begin
 * added for kernel upgrade from 2.6.18.6 to 2.6.23.1
 *
 */
    .boot_params    = ASPEED_SDRAM_BASE + 0x100,
/* AVOCENT - AndyC end */

	.io_pg_offst		= (IO_ADDRESS(IO_START)>>18) & 0xfffc,
	.map_io			= aspeed_map_io,
	.timer			= &aspeed_timer,
	.init_irq		= aspeed_init_irq,
	.init_machine		= aspeed_init,
MACHINE_END
