/*
 * include/asm-arm/arch-umvp/entry-macro.S
 *
 * Low-level IRQ helper macros for GUC-MVP2000 platforms
 *
 * This file is licensed under the terms of the GNU General Public
 * License version 2. This program is licensed "as is" without any
 * warranty of any kind, whether express or implied.
 */
#include <asm/hardware.h>
#include <asm/arch/irqs.h>

		.macro	disable_fiq
		.endm


        .macro  get_irqnr_preamble, base, tmp
        ldr \base, =IO_ADDRESS(ASPEED_VIC_BASE)
        .endm

        .macro  arch_ret_to_user, tmp1, tmp2
        .endm


#if 1

#if defined(CONFIG_AST2100DFB)
		.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
/* FIXME: should not be using soo many LDRs here */
		ldr	\irqnr, =IO_ADDRESS(ASPEED_VIC_BASE)
		ldr	\irqstat, [\irqnr, #ASPEED_VIC_STATUS_OFFSET]		@ get masked status
		
		ldr	\tmp, =IO_ADDRESS(ASPEED_SCU_BASE)
		ldr	\irqnr, [\tmp, #0x44]
                and     \irqnr, \irqnr, #31
                mov     \irqstat, \irqstat, ror \irqnr 
                clz     \tmp, \irqstat
                cmp     \tmp, #32
                beq     1005f
                
                add     \irqnr, \irqnr, #31
                sub     \irqnr, \irqnr, \tmp
		and     \irqnr, \irqnr, #31
		
		ldr	\tmp, =IO_ADDRESS(ASPEED_SCU_BASE)
		str	\irqnr, [\tmp, #0x44]
		
1002:		/* VIC2 */
		cmp	\irqnr, #IRQ_VIC2
		bne	1005f
	
		ldr	\base, =IO_ADDRESS(ASPEED_GPIO_BASE)
		ldr	\irqstat, [\base, #ASPEED_VIC2_STATUS_OFFSET]		@ get masked status
		mov	\irqstat, \irqstat, lsr #8				@ GPIO B
		mov	\tmp, #32						@ IRQ Number
1003:  		tst	\irqstat, #1
		bne	1004f
		add	\tmp, \tmp, #1
		mov	\irqstat, \irqstat, lsr #1
		cmp	\tmp, #36
		blt	1003b
		b	1005f
1004:  		mov	\irqnr, \tmp
1005:		/* done */
		.endm
#else
		.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
/* FIXME: should not be using soo many LDRs here */
		ldr	\irqnr, =IO_ADDRESS(ASPEED_VIC_BASE)
		ldr	\irqstat, [\irqnr, #ASPEED_VIC_STATUS_OFFSET]		@ get masked status
		
		ldr	\tmp, =IO_ADDRESS(ASPEED_SCU_BASE)
		ldr	\irqnr, [\tmp, #0x44]
                and     \irqnr, \irqnr, #31
                mov     \irqstat, \irqstat, ror \irqnr 
                clz     \tmp, \irqstat
                cmp     \tmp, #32
                beq     1001f
                
                add     \irqnr, \irqnr, #31
                sub     \irqnr, \irqnr, \tmp
		and     \irqnr, \irqnr, #31
		
		ldr	\tmp, =IO_ADDRESS(ASPEED_SCU_BASE)
		str	\irqnr, [\tmp, #0x44]
                cmp     \irqnr, #32

#if 0
                mov    \irqnr, #31
                clz    \tmp, \irqstat
                cmp    \tmp, #32
                beq     1001f 
                sub    \irqnr, \irqnr, \tmp
                cmp    \irqnr, #32
#endif
1001:		/* done */
		.endm
#endif

#else

#if defined(CONFIG_AST2100DFB)
		.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
/* FIXME: should not be using soo many LDRs here */
		ldr	\irqnr, =IO_ADDRESS(ASPEED_VIC_BASE)
		ldr	\irqstat, [\irqnr, #ASPEED_VIC_STATUS_OFFSET]		@ get masked status

		/* VIC1 */
		mov	\irqnr, #0
1001:		tst	\irqstat, #1
		bne	1002f
		add	\irqnr, \irqnr, #1
		mov	\irqstat, \irqstat, lsr #1
		cmp	\irqnr, #31
		bcc	1001b
		b	1005f
		
1002:		/* VIC2 */
		cmp	\irqnr, #IRQ_VIC2
		bne	1005f
	
		ldr	\base, =IO_ADDRESS(ASPEED_GPIO_BASE)
		ldr	\irqstat, [\base, #ASPEED_VIC2_STATUS_OFFSET]		@ get masked status
		mov	\irqstat, \irqstat, lsr #8				@ GPIO B
		mov	\tmp, #32						@ IRQ Number
1003:  		tst	\irqstat, #1
		bne	1004f
		add	\tmp, \tmp, #1
		mov	\irqstat, \irqstat, lsr #1
		cmp	\tmp, #36
		blt	1003b
		b	1005f
1004:  		mov	\irqnr, \tmp
1005:		/* done */
		.endm
#else
		.macro	get_irqnr_and_base, irqnr, irqstat, base, tmp
/* FIXME: should not be using soo many LDRs here */
		ldr	\irqnr, =IO_ADDRESS(ASPEED_VIC_BASE)
		ldr	\irqstat, [\irqnr, #ASPEED_VIC_STATUS_OFFSET]		@ get masked status

		mov	\irqnr, #0
1001:		tst	\irqstat, #1
		bne	1002f
		add	\irqnr, \irqnr, #1
		mov	\irqstat, \irqstat, lsr #1
		cmp	\irqnr, #31
		bcc	1001b
1002:		/* EQ will be set if we reach 31 */
		.endm
#endif

#endif
		.macro	irq_prio_table
		.endm

